#include	<windows.h>
#include	<stdio.h>
#include	<string.h>
#include	<ddraw.h>

#include	"common.h"
#include	"resource.h"
#include	"ini.h"
#include	"xmil.h"
#include	"draw.h"
#include	"ddraws.h"
#include	"menu.h"
#include	"palettes.h"
#include	"x1.h"
#include	"x1_crtc.h"

static	RECT	rect200 = {0, 0, SCREEN_WIDTH, SCREEN_HEIGHT};
static	RECT	rectdraw1 = {0, 0, SCREEN_WIDTH, 1};
extern	HWND	hWndMain;

static	LPDIRECTDRAW			pDDraw1 = NULL;
static	LPDIRECTDRAW2			pDDraw = NULL;
static	LPDIRECTDRAWSURFACE		pPrimSurf = NULL;
static	LPDIRECTDRAWSURFACE		pBackSurf = NULL;
static	LPDIRECTDRAWCLIPPER		pClipper = NULL;
static	LPDIRECTDRAWPALETTE		pPalette = NULL;
static	PALETTEENTRY			palettes[256];
static	BYTE					allflash = 0;

static	BYTE	palchanged = 0;
static	BYTE	SCREENMODE = 0;
		BYTE	drawingmode = 0;

		PALETTE_TABLE	xm_palette[256];
		BYTE			screenmap[SCREEN_WIDTH * SCREEN_HEIGHT];
		BYTE			renewalline[SCREEN_HEIGHT+2];
		BYTE			x2mode = 1;
		WORD			putlines = SCREEN_HEIGHT;
		WORD			xm_pal16[256];

		WORD			xm_r16b;
		WORD			xm_r16r;
		WORD			xm_r16g;
		WORD			xm_l16b;
		WORD			xm_l16r;
		WORD			xm_l16g;

extern	int				winx, winy;
extern	BYTE			windowed;
static	int				winw = 640;
static	int				winh = 400;

__inline void fillrenewalline(DWORD value) {

	int		cnt = SCREEN_HEIGHT / 4;
	DWORD	*p = (DWORD *)renewalline;
	while(cnt--) {
		*p++ |= value;
	}
}


void xm_initwindowsize(WORD width, WORD height) {

	RECT	rectWindow, rectClient;
	int		scx, scy;

	GetWindowRect(hWndMain, &rectWindow);
	GetClientRect(hWndMain, &rectClient);
	winw = width + (rectWindow.right - rectWindow.left)
					- (rectClient.right - rectClient.left);
	winh = height + (rectWindow.bottom - rectWindow.top)
					- (rectClient.bottom - rectClient.top);

	scx = GetSystemMetrics(SM_CXSCREEN);
	scy = GetSystemMetrics(SM_CYSCREEN);

	if (scx < winw) {
		INIT_RENEWAL
			winx = (scx - winw) / 2;
	}
	else if (winx < 0) {
		INIT_RENEWAL
			winx = 0;
	}
	else if ((winx + winw) > scx) {
		INIT_RENEWAL
			winx = scx - winw;
	}
	if (scy < winh) {
		INIT_RENEWAL
			winy = (scy - winh) / 2;
	}
	else if (winy < 0) {
		INIT_RENEWAL
			winy = 0;
	}
	else if ((winy + winh) > scy) {
		INIT_RENEWAL
			winy = scy - winh;
	}
}


void xm_windowstats(BYTE winflg) {

	DWORD	winstyle, winstyleex;
	HMENU	hmenu = GetMenu(hWndMain);

	winstyle = GetWindowLong(hWndMain, GWL_STYLE);
	winstyleex = GetWindowLong(hWndMain, GWL_EXSTYLE);
	windowed = winflg;
	if (windowed) {
		winstyle = (winstyle | WS_CAPTION | WS_OVERLAPPED | WS_SYSMENU)
																& ~WS_POPUP;
		winstyleex &= ~WS_EX_TOPMOST;
		SetWindowLong(hWndMain, GWL_STYLE, winstyle);
		SetWindowLong(hWndMain, GWL_EXSTYLE, winstyleex);

		MoveWindow(hWndMain, winx, winy, winw, winh, TRUE);

		CheckMenuItem(hmenu, IDM_WINDOW, MF_CHECKED);
		CheckMenuItem(hmenu, IDM_FULLSCREEN, MF_UNCHECKED);
	}
	else {
		winstyle = (winstyle | WS_POPUP)
						& (~(WS_CAPTION | WS_OVERLAPPED | WS_SYSMENU));
		winstyleex |= WS_EX_TOPMOST;
		SetWindowLong(hWndMain, GWL_STYLE, winstyle);
		SetWindowLong(hWndMain, GWL_EXSTYLE, winstyleex);
		CheckMenuItem(hmenu, IDM_WINDOW, MF_UNCHECKED);
		CheckMenuItem(hmenu, IDM_FULLSCREEN, MF_CHECKED);
	}
}


void ddraws_init(void) {

	ZeroMemory(screenmap, sizeof(screenmap));
	ZeroMemory(xm_palette, sizeof(xm_palette));
	allflash = 1;
	fillrenewalline(0x03030303);
	xmenu_setwidth(x2mode);
}


void change_palette(void) {

	int		i;

	if (SCREENMODE & SCMD_USEPAL) {
		palchanged = 1;
		fillrenewalline(0x02020202);
	}
	else {
		if (SCREENMODE == SCMD_WINDOW16) {
			for (i=0; i<USE_PALS; i++) {
				xm_pal16[i] = ((xm_palette[i].b.red >> xm_r16r) << xm_l16r) |
							((xm_palette[i].b.green >> xm_r16g) << xm_l16g) |
							((xm_palette[i].b.blue >> xm_r16b) << xm_l16b);
			}
		}
		fillrenewalline(0x03030303);
	}
}


static void palette_init(void) {

	BYTE	i;
	HDC 	hdc = GetDC(hWndMain);

	GetSystemPaletteEntries(hdc, 0, 256, palettes);
	ReleaseDC(hWndMain, hdc);

	for (i=START_PAL; i<(START_PAL + TOTAL_PALS); i++) {
		palettes[i].peFlags = PC_RESERVED | PC_NOCOLLAPSE;
	}
	reflesh_palette();
	pDDraw->CreatePalette(DDPCAPS_8BIT, palettes, &pPalette, 0);
	pPrimSurf->SetPalette(pPalette);
	palchanged = 0;
}


static void palette_set(void) {

	int		i;
	int		c;

	if (pPalette != NULL) {
		for (i=0; i<USE_PALS; i++) {
			palettes[i+START_PAL].peRed = xm_palette[i].b.red;
			palettes[i+START_PAL].peBlue = xm_palette[i].b.blue;
			palettes[i+START_PAL].peGreen = xm_palette[i].b.green;
		}
		for (i=0; i<0x18; i++) {
			palettes[i+START_EXT].peRed = TEXTPALS[i].b.red;
			palettes[i+START_EXT].peBlue = TEXTPALS[i].b.blue;
			palettes[i+START_EXT].peGreen = TEXTPALS[i].b.green;
		}
		c = ((~crtc.EXTPALMODE) >> 4) & 8;
		for (i=0; i<8; i++, c++) {
			palettes[i+START_EXT+0x18].peRed = GRPHPALS[c].b.red;
			palettes[i+START_EXT+0x18].peBlue = GRPHPALS[c].b.blue;
			palettes[i+START_EXT+0x18].peGreen = GRPHPALS[c].b.green;
			palettes[i+START_EXT+0x20].peRed = GRPHPALS[c+16].b.red;
			palettes[i+START_EXT+0x20].peBlue = GRPHPALS[c+16].b.blue;
			palettes[i+START_EXT+0x20].peGreen = GRPHPALS[c+16].b.green;
		}
		pPalette->SetEntries(0, START_PAL, TOTAL_PALS, &palettes[START_PAL]);
	}
}


void clearblankarea(void) {

	DDBLTFX		ddbf;
	RECT		fill1rect = {0, 0, FULLSCREEN_WIDTH, FULLSCREEN_POSY};
	RECT		fill2rect = {0, FULLSCREEN_HEIGHT - FULLSCREEN_POSY,
								FULLSCREEN_WIDTH, FULLSCREEN_HEIGHT};

	ZeroMemory(&ddbf, sizeof(ddbf));
	ddbf.dwSize = sizeof(ddbf);
	ddbf.dwFillColor = 0;
	pPrimSurf->Blt(&fill1rect, NULL, NULL, DDBLT_COLORFILL, &ddbf);
	pPrimSurf->Blt(&fill2rect, NULL, NULL, DDBLT_COLORFILL, &ddbf);
}

static void make16bit(WORD *shlcnt, WORD *shrcnt, DWORD bitmap) {

	WORD	bit = 1;
	WORD	cnt;

	for (cnt=0; (cnt<16) && (!(bitmap & bit)); cnt++, bit<<=1) ;
	*shlcnt = cnt;
	for (cnt=8; (cnt) && (bitmap & bit); cnt--, bit<<=1) ;
	*shrcnt = cnt;
}


int xm_InitDirectDraw(void) {

	DDSURFACEDESC	ddsd;
	DDPIXELFORMAT	ddpf;

	pDDraw1 = NULL;
	pDDraw = NULL;
	pPrimSurf = NULL;
	pBackSurf = NULL;
	pClipper = NULL;
	pPalette = NULL;
	palchanged = 0;

	if (DirectDrawCreate(NULL, &pDDraw1, NULL) != DD_OK) {
		return(FAILURE);
	}
	pDDraw1->QueryInterface(IID_IDirectDraw2, (void **)&pDDraw);

	if (windowed) {
		pDDraw->SetCooperativeLevel(hWndMain, DDSCL_NORMAL);

		ZeroMemory(&ddsd, sizeof(ddsd));
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;

		if (pDDraw->CreateSurface(&ddsd, &pPrimSurf, NULL) != DD_OK) {
			return(FAILURE);
		}

		pDDraw->CreateClipper(0, &pClipper, NULL);
		pClipper->SetHWnd(0, hWndMain);
		pPrimSurf->SetClipper(pClipper);

		ZeroMemory(&ddpf, sizeof(ddpf));
		ddpf.dwSize = sizeof(DDPIXELFORMAT);
		if (DD_OK != pPrimSurf->GetPixelFormat(&ddpf)) {
			return(FAILURE);
		}

		ZeroMemory(&ddsd, sizeof(ddsd));
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
		ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
		ddsd.dwWidth = SCREEN_WIDTH;
		ddsd.dwHeight = SCREEN_HEIGHT;

		if (pDDraw->CreateSurface(&ddsd, &pBackSurf, NULL) != DD_OK) {
			return(FAILURE);
		}
		if (ddpf.dwRGBBitCount == 8) {
			palette_init();
			SCREENMODE = SCMD_WINDOW8;
		}
		else if (ddpf.dwRGBBitCount == 16) {
			SCREENMODE = SCMD_WINDOW16;
			make16bit(&xm_l16b, &xm_r16b, ddpf.dwBBitMask);
			make16bit(&xm_l16r, &xm_r16r, ddpf.dwRBitMask);
			make16bit(&xm_l16g, &xm_r16g, ddpf.dwGBitMask);
		}
		else if (ddpf.dwRGBBitCount == 24) {
			SCREENMODE = SCMD_WINDOW24;
		}
		else if (ddpf.dwRGBBitCount == 32) {
			SCREENMODE = SCMD_WINDOW32;
		}
		else {
			return(FAILURE);
		}
	}
	else {
		pDDraw->SetCooperativeLevel(hWndMain,
					DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT);
		if (pDDraw->SetDisplayMode(FULLSCREEN_WIDTH, FULLSCREEN_HEIGHT,
													 8, 0, 0) != DD_OK) {
			return(FAILURE);
		}
		pDDraw->CreateClipper(0, &pClipper, NULL);
		pClipper->SetHWnd(0, hWndMain);

		ZeroMemory(&ddsd, sizeof(ddsd));
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
		if (pDDraw->CreateSurface(&ddsd, &pPrimSurf, NULL) != DD_OK) {
			return(FAILURE);
		}
		clearblankarea();

		ZeroMemory(&ddsd, sizeof(ddsd));
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
		ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
		ddsd.dwWidth = FULLSCREEN_WIDTH;
		ddsd.dwHeight = SCREEN_HEIGHT;
		if (pDDraw->CreateSurface(&ddsd, &pBackSurf, NULL) != DD_OK) {
			return(FAILURE);
		}

		palette_init();
		SCREENMODE = SCMD_FULLSCREEN;
	}
	return(SUCCESS);
}


void xm_TermDirectDraw(void) {

	if ((SCREENMODE == SCMD_FULLSCREEN) && (pDDraw)) {
//		pDDraw->RestoreDisplayMode();
		pDDraw->SetCooperativeLevel(hWndMain, DDSCL_NORMAL);
	}
	RELEASE(pBackSurf);
	RELEASE(pPalette);
	RELEASE(pClipper);
	RELEASE(pPrimSurf);
	RELEASE(pDDraw);
	RELEASE(pDDraw1);
}

void change_drawlines(DWORD lines) {

	if (lines > SCREEN_HEIGHT) {
		lines = SCREEN_HEIGHT;
	}
	rect200.bottom = lines;
	allflash = 1;
}

void clearblanklines(DWORD posx, DWORD posy) {

	DDBLTFX		ddbf;
	RECT		fillrect;

	fillrect.left = posx;
	fillrect.top = posy + rect200.bottom;
	fillrect.right = posx + SCREEN_WIDTH;
	fillrect.bottom = posy + SCREEN_HEIGHT;

	ZeroMemory(&ddbf, sizeof(ddbf));
	ddbf.dwSize = sizeof(ddbf);
	ddbf.dwFillColor = 0;
	pPrimSurf->Blt(&fillrect, NULL, NULL, DDBLT_COLORFILL, &ddbf);
}


		// DirectXŊg債Ȃ̂́ÃBfIJ[hɃoO()
void scrn_draws(void) {

	DDSURFACEDESC	ddsd;

	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);

	if (pBackSurf->Lock(NULL, &ddsd, DDLOCK_WAIT, NULL) != DD_OK) {
		return;
	}

	switch(SCREENMODE) {
		case SCMD_FULLSCREEN:
		case SCMD_WINDOW8:
			if (x2mode) {
					__asm {
						push	esi
						push	edi
						mov		esi, offset screenmap
						mov		edi, ddsd.lpSurface
						xor		edx, edx
						mov		ebx, offset renewalline
x2win8bppdrlp1:			btr		word ptr [ebx], 0
						jnc		x2win8bppdred
						push	esi
						push	edi
						mov		cx, SCREEN_WIDTH/4
x2win8bppdrlp2:			mov		ax, [esi]
						add		ax, 0x0101 * START_PAL
						mov		[edi], al
						mov		[edi+1], ax
						mov		[edi+3], ah
						add		esi, 2
						add		edi, 4
						dec		cx
						jne		x2win8bppdrlp2
						pop		edi
						pop		esi
x2win8bppdred:			add		esi, SCREEN_WIDTH
						add		edi, ddsd.lPitch
						inc		ebx
						inc		dx
						cmp		dx, SCREEN_HEIGHT
						jc		x2win8bppdrlp1
						pop		edi
						pop		esi
					}
			}
			else {
					__asm {
						push	esi
						push	edi
						mov		esi, offset screenmap
						mov		edi, ddsd.lpSurface
						xor		edx, edx
						mov		ebx, offset renewalline
x1win8bppdrlp1:			btr		word ptr [ebx], 0
						jnc		x1win8bppdred
						push	esi
						push	edi
						mov		cx, SCREEN_WIDTH/4
x1win8bppdrlp2:			mov		eax, [esi]
						add		eax, 0x01010101 * START_PAL
						mov		[edi], eax
						add		esi, 4
						add		edi, 4
						dec		cx
						jne		x1win8bppdrlp2
						pop		edi
						pop		esi
x1win8bppdred:			add		esi, SCREEN_WIDTH
						add		edi, ddsd.lPitch
						inc		ebx
						inc		dx
						cmp		dx, SCREEN_HEIGHT
						jc		x1win8bppdrlp1
						pop		edi
						pop		esi
					}
			}
			break;
		case SCMD_WINDOW16:
			if (x2mode) {
					__asm {
						push	esi
						push	edi
						mov		esi, offset screenmap
						mov		edi, ddsd.lpSurface
						xor		edx, edx
						mov		ebx, offset renewalline
x2win16bppdrlp1:		btr		word ptr [ebx], 0
						jnc		x2win16bppdred
						push	esi
						push	edi
						mov		cx, SCREEN_WIDTH/2
x2win16bppdrlp2:		movzx	eax, byte ptr [esi]
						mov		ax, word ptr xm_pal16[eax*2]
						mov		[edi], ax
						mov		[edi+2], ax
						inc		esi
						add		edi, 4
						dec		cx
						jne		x2win16bppdrlp2
						pop		edi
						pop		esi
x2win16bppdred:			add		esi, SCREEN_WIDTH
						add		edi, ddsd.lPitch
						inc		ebx
						inc		dx
						cmp		dx, putlines
						jc		x2win16bppdrlp1
						pop		edi
						pop		esi
					}
			}
			else {
					__asm {
						push	esi
						push	edi
						mov		esi, offset screenmap
						mov		edi, ddsd.lpSurface
						xor		edx, edx
						mov		ebx, offset renewalline

x1win16bppdrlp1:		btr		word ptr [ebx], 0
						jnc		x1win16bppdred
						push	esi
						push	edi
						mov		cx, SCREEN_WIDTH
x1win16bppdrlp2:		movzx	eax, byte ptr [esi]
						mov		ax, word ptr xm_pal16[eax*2]
						mov		[edi], ax
						inc		esi
						add		edi, 2
						dec		cx
						jne		x1win16bppdrlp2
						pop		edi
						pop		esi
x1win16bppdred:			add		esi, SCREEN_WIDTH
						add		edi, ddsd.lPitch
						inc		ebx
						inc		dx
						cmp		dx, putlines
						jc		x1win16bppdrlp1
						pop		edi
						pop		esi
					}
			}
			break;
		case SCMD_WINDOW24:
			if (x2mode) {
					__asm {
						push	esi
						push	edi
						mov		esi, offset screenmap
						mov		edi, ddsd.lpSurface
						xor		edx, edx
						mov		ebx, offset renewalline
x2win24bppdrlp1:		btr		word ptr [ebx], 0
						jnc		x2win24bppdred
						push	esi
						push	edi
						mov		cx, (SCREEN_WIDTH/2) - 1
x2win24bppdrlp2:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr xm_palette[eax*4]
						mov		[edi], eax
						mov		[edi+3], eax
						inc		esi
						add		edi, 6
						dec		cx
						jne		x2win24bppdrlp2
						movzx	eax, byte ptr [esi]
						mov		eax, dword ptr xm_palette[eax*4]
						mov		[edi], eax
						mov		[edi+3], al
						shr		eax, 8
						mov		[edi+4], ax
						pop		edi
						pop		esi
x2win24bppdred:			add		esi, SCREEN_WIDTH
						add		edi, ddsd.lPitch
						inc		ebx
						inc		dx
						cmp		dx, putlines
						jc		x2win24bppdrlp1
						pop		edi
						pop		esi
				}
			}
			else {
					__asm {
						push	esi
						push	edi
						mov		esi, offset screenmap
						mov		edi, ddsd.lpSurface
						xor		edx, edx
						mov		ebx, offset renewalline

x1win24bppdrlp1:		btr		word ptr [ebx], 0
						jnc		x1win24bppdred
						push	esi
						push	edi
						mov		cx, SCREEN_WIDTH - 1
x1win24bppdrlp2:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr xm_palette[eax*4]
						mov		[edi], eax
						inc		esi
						add		edi, 3
						dec		cx
						jne		x1win24bppdrlp2
						movzx	eax, byte ptr [esi]
						mov		eax, dword ptr xm_palette[eax*4]
						mov		[edi], al
						shr		eax, 8
						mov		[edi+1], ax
						pop		edi
						pop		esi
x1win24bppdred:			add		esi, SCREEN_WIDTH
						add		edi, ddsd.lPitch
						inc		ebx
						inc		dx
						cmp		dx, putlines
						jc		x1win24bppdrlp1
						pop		edi
						pop		esi
					}
			}
			break;
		case SCMD_WINDOW32:
			if (x2mode) {
					__asm {
						push	esi
						push	edi
						mov		esi, offset screenmap
						mov		edi, ddsd.lpSurface
						xor		edx, edx
						mov		ebx, offset renewalline
x2win32bppdrlp1:		btr		word ptr [ebx], 0
						jnc		x2win32bppdred
						push	esi
						push	edi
						mov		cx, SCREEN_WIDTH/2
x2win32bppdrlp2:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr xm_palette[eax*4]
						and		eax, 00ffffffh
						mov		[edi], eax
						mov		[edi+4], eax
						inc		esi
						add		edi, 8
						dec		cx
						jne		x2win32bppdrlp2
						pop		edi
						pop		esi
x2win32bppdred:			add		esi, SCREEN_WIDTH
						add		edi, ddsd.lPitch
						inc		ebx
						inc		dx
						cmp		dx, putlines
						jc		x2win32bppdrlp1
						pop		edi
						pop		esi
					}
			}
			else {
					__asm {
						push	esi
						push	edi
						mov		esi, offset screenmap
						mov		edi, ddsd.lpSurface
						xor		edx, edx
						mov		ebx, offset renewalline

x1win32bppdrlp1:		btr		word ptr [ebx], 0
						jnc		x1win32bppdred
						push	esi
						push	edi
						mov		cx, SCREEN_WIDTH
x1win32bppdrlp2:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr xm_palette[eax*4]
						and		eax, 00ffffffh
						mov		[edi], eax
						inc		esi
						add		edi, 4
						dec		cx
						jne		x1win32bppdrlp2
						pop		edi
						pop		esi
x1win32bppdred:			add		esi, SCREEN_WIDTH
						add		edi, ddsd.lPitch
						inc		ebx
						inc		dx
						cmp		dx, putlines
						jc		x1win32bppdrlp1
						pop		edi
						pop		esi
					}
			}
			break;
	}
	pBackSurf->Unlock(NULL);
}


void scrn_drawall(void) {

	POINT	pt;
	RECT	rectDst;

	switch(SCREENMODE) {
		case SCMD_WINDOW8:
			if (palchanged) {
				palchanged = 0;
				palette_set();
			}
			if (pBackSurf != NULL) {
				pt.x = 0;
				pt.y = 0;
				ClientToScreen(hWndMain, &pt);
				SetRect(&rectDst, pt.x, pt.y, pt.x + SCREEN_WIDTH,
								pt.y + rect200.bottom);
				if (pPrimSurf->Blt(&rectDst, pBackSurf, &rect200,
									DDBLT_WAIT, NULL) == DDERR_SURFACELOST) {
					pPrimSurf->Restore();
					pBackSurf->Restore();
				}
				if (allflash) {
					allflash = 0;
					clearblanklines(pt.x, pt.y);
				}
			}
			break;
		case SCMD_WINDOW16:
		case SCMD_WINDOW24:
		case SCMD_WINDOW32:
			if (pBackSurf != NULL) {
				pt.x = 0;
				pt.y = 0;
				ClientToScreen(hWndMain, &pt);
				SetRect(&rectDst, pt.x, pt.y, pt.x + SCREEN_WIDTH,
								pt.y + rect200.bottom);
				if (pPrimSurf->Blt(&rectDst, pBackSurf, &rect200,
									DDBLT_WAIT, NULL) == DDERR_SURFACELOST) {
					pPrimSurf->Restore();
					pBackSurf->Restore();
				}
				if (allflash) {
					allflash = 0;
					clearblanklines(pt.x, pt.y);
				}
			}
			break;
		case SCMD_FULLSCREEN:
			if (palchanged) {
				palchanged = 0;
				palette_set();
			}
			if (pBackSurf != NULL) {
				if (pPrimSurf->BltFast(0, FULLSCREEN_POSY, pBackSurf,
							&rect200, DDBLTFAST_WAIT) == DDERR_SURFACELOST) {
					pPrimSurf->Restore();
					pBackSurf->Restore();
				}
				if (allflash) {
					allflash = 0;
					clearblanklines(0, FULLSCREEN_POSY);
				}
			}
			break;
	}
}

BYTE scrn_restore(void) {

	if (pBackSurf->IsLost() == DDERR_SURFACELOST) {
		pBackSurf->Restore();
		allflash = 1;
		fillrenewalline(0x03030303);
		return(1);
	}
	return(0);
}

void scrn_palette(void) {

	if (pPalette) {
		pPrimSurf->SetPalette(pPalette);
	}
}


void change_xmode(BYTE x2flag) {

	if (x2mode != x2flag) {
		x2mode = x2flag;
		xmenu_setwidth(x2mode);
		fillrenewalline(0x03030303);
	}
}

void mx_topwinui(void) {

	if (!windowed) {
		pPrimSurf->SetClipper(pClipper);
	}
}

void mx_clearwinui(void) {

	if (!windowed) {
		pPrimSurf->SetClipper(0);
		clearblankarea();
	}
}


BYTE scrn_draw1(DWORD linepos) {

	DDSURFACEDESC	ddsd;

	if (!(renewalline[linepos] & 2)) {
		return(0);
	}
	renewalline[linepos] ^= 2;

	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	rectdraw1.top = linepos;
	rectdraw1.bottom = linepos + 1;

	if (pBackSurf->Lock(&rectdraw1, &ddsd, DDLOCK_WAIT, NULL) != DD_OK) {
		return(0);
	}
	__asm {
				mov		eax, SCREEN_WIDTH
				mul		dword ptr linepos
				lea		ebx, screenmap[eax]
				mov		edx, ddsd.lpSurface

				mov		al, SCREENMODE
				cmp		al, SCMD_FULLSCREEN
				je		d1_scrnbit8
				cmp		al, SCMD_WINDOW32
				je		d1_scrnbit32
				cmp		al, SCMD_WINDOW24
				je		d1_scrnbit24
				cmp		al, SCMD_WINDOW16
				je		d1_scrnbit16

d1_scrnbit8:		cmp		x2mode, 0
					je		d1_scrnbit8x1

						mov		cx, SCREEN_WIDTH/2
x2win8bppdrlp:			movzx	eax, byte ptr [ebx]
						mov		al, byte ptr xm_palette[eax*4+3]
						mov		ah, al
						mov		[edx], ax
						inc		ebx
						add		edx, 2
						dec		cx
						jne		x2win8bppdrlp
						jmp		draw1lock

d1_scrnbit8x1:			mov		cx, SCREEN_WIDTH
x1win8bppdrlp:			movzx	eax, byte ptr [ebx]
						mov		al, byte ptr xm_palette[eax*4+3]
						mov		[edx], al
						inc		ebx
						inc		edx
						dec		cx
						jne		x1win8bppdrlp
						jmp		draw1lock

d1_scrnbit16:		cmp		x2mode, 0
					je		d1_scrnbit16x1

						mov		cx, SCREEN_WIDTH/2
x2win16bppdrlp:			movzx	eax, byte ptr [ebx]
						mov		ax, word ptr xm_pal16[eax*2]
						mov		[edx], ax
						mov		[edx+2], ax
						inc		ebx
						add		edx, 4
						dec		cx
						jne		x2win16bppdrlp
						jmp		draw1lock

d1_scrnbit16x1:			mov		cx, SCREEN_WIDTH
x1win16bppdrlp:			movzx	eax, byte ptr [ebx]
						mov		ax, word ptr xm_pal16[eax*2]
						mov		[edx], ax
						inc		ebx
						add		edx, 2
						dec		cx
						jne		x1win16bppdrlp
						jmp		draw1lock

d1_scrnbit24:		cmp		x2mode, 0
					je		d1_scrnbit24x1

						mov		cx, (SCREEN_WIDTH/2) - 1
x2win24bppdrlp:			movzx	eax, byte ptr [ebx]
						mov		eax, dword ptr xm_palette[eax*4]
						mov		[edx], eax
						mov		[edx+3], eax
						inc		ebx
						add		edx, 6
						dec		cx
						jne		x2win24bppdrlp
						movzx	eax, byte ptr [ebx]
						mov		eax, dword ptr xm_palette[eax*4]
						mov		[edx], eax
						mov		[edx+3], al
						shr		eax, 8
						mov		[edx+4], ax
						jmp		draw1lock

d1_scrnbit24x1:			mov		ebx, offset screenmap
						mov		edx, ddsd.lpSurface
						mov		cx, SCREEN_WIDTH - 1
x1win24bppdrlp:			movzx	eax, byte ptr [ebx]
						mov		eax, dword ptr xm_palette[eax*4]
						mov		[edx], eax
						inc		ebx
						add		edx, 3
						dec		cx
						jne		x1win24bppdrlp
						movzx	eax, byte ptr [ebx]
						mov		eax, dword ptr xm_palette[eax*4]
						mov		[edx], al
						shr		eax, 8
						mov		[edx+1], ax
						jmp		draw1lock

d1_scrnbit32:		cmp		x2mode, 0
					je		d1_scrnbit32x1

						mov		cx, SCREEN_WIDTH/2
x2win32bppdrlp:			movzx	eax, byte ptr [ebx]
						mov		eax, dword ptr xm_palette[eax*4]
						and		eax, 00ffffffh
						mov		[edx], eax
						mov		[edx+4], eax
						inc		ebx
						add		edx, 8
						dec		cx
						jne		x2win32bppdrlp
						jmp		draw1lock

d1_scrnbit32x1:			mov		cx, SCREEN_WIDTH
x1win32bppdrlp:			movzx	eax, byte ptr [ebx]
						mov		eax, dword ptr xm_palette[eax*4]
						and		eax, 00ffffffh
						mov		[edx], eax
						inc		ebx
						add		edx, 4
						dec		cx
						jne		x1win32bppdrlp
draw1lock:
		}
	pBackSurf->Unlock(NULL);
	return(1);
}


void ddraws_redraw(void) {

	allflash = 1;
	palchanged = 1;
	fillrenewalline(0x03030303);
	scrn_draws();
	scrn_drawall();
}
