#include	<windows.h>
#include	<stdio.h>
#include	<string.h>
#include	"xmil.h"
#include	"x1.h"
#include	"x1_scpu.h"
#include	"x1_8255.h"
#include	"x1_pcg.h"
#include	"x1_crtc.h"
#include	"x1_vram.h"
#include	"x1_fdc.h"
#include	"x1_dma.h"
#include	"x1_dmam.h"
#include	"x1_ctc.h"
#include	"x1_clndr.h"
#include	"x1_sio.h"
#include	"x1_sound.h"
#include	"input.h"
#include	"draw.h"
#include	"timer.h"
#include	"dosio.h"
#include	"trace.h"
#include	"dsounds.h"
#include	"menu.h"
#include	"deffnt.h"
#include	"otherfnt.h"

	X1_FLAG		x1flg = {250, 0, 1, 1, 0};
	BYTE		mMAIN[0x10000];
	BYTE		mBIOS[0x8000];
	BYTE		mBANK[16][0x8000];
	BYTE		KNJ_FNT[0x4bc00];
	BYTE		GRP_00[0xc000];
	BYTE		GRP_01[0xc000];
	BYTE		TXT_RAM[0x1800];
	WORD		v_cnt;
	int			s_cnt;

	BYTE		*RAM0r;
	BYTE		*RAM0w;


/***********************************************************************
	IPL-ROM LOAD
***********************************************************************/

const	BYTE	IPLFILE[] = "IPLROM.X1";
const	BYTE	TURBOIPLFILE[] = "IPLROM.X1T";

void ipl_load(void) {

	FILEH	hdl;

	ZeroMemory(mBIOS, sizeof(mBIOS));
	memcpy(mBIOS, DEFROM, sizeof(DEFROM));

	if (x1flg.ROM_TYPE >= 2) {
		if ((hdl = file_open_c((LPSTR)TURBOIPLFILE)) != (FILEH)-1) {
			file_read(hdl, mBIOS, 0x8000);
			file_close(hdl);
		}
	}
	else if (x1flg.ROM_TYPE == 1) {
		if ((hdl = file_open_c((LPSTR)IPLFILE)) != (FILEH)-1) {
			file_read(hdl, mBIOS, 0x8000);
			file_close(hdl);
		}
	}
}


/***********************************************************************
	FONT-ROM LOAD
***********************************************************************/

void fnt_load(void) {

	FILEH	fh;
	BYTE	loaded = 0;

	if ((fh = file_open_c("FNT0808.X1")) != (FILEH)-1) {
		file_read(fh, ANK_FNT[0], 8*256);
		file_close(fh);
		loaded |= FONT_ANK8;
	}

	if ((fh = file_open_c("FNT0816.X1")) != (FILEH)-1) {
		file_read(fh, KNJ_FNT, 0x1000);
		file_close(fh);
		loaded |= FONT_ANK16a | FONT_ANK16b;
	}
	if ((fh = file_open_c("FNT1616.X1")) != (FILEH)-1) {
		file_lread(fh, &KNJ_FNT[0x1000], 0x4ac00);
		file_close(fh);
		loaded |= FONT_KNJ1 | FONT_KNJ2;
	}

	if ((~loaded) & (FONT_ANK16a | FONT_KNJ1)) {
		loaded |= fm7fontread(loaded);
	}

	if (loaded != FONT_ALL) {
		loaded |= pc88fontread(loaded);
	}

	if ((~loaded) & (FONT_ALL ^ FONT_ANK8)) {
		loaded |= t98fontread(loaded);
	}

	// Ō ANK16̃pb`
	patch_ank16();
}


/***********************************************************************
	
***********************************************************************/

void reset_x1(BYTE ROM_TYPE, BYTE SOUND_SW, BYTE DIP_SW) {

	x1_psg_reset();
	x1_opm_reset();

	x1flg.HSYNC_CLK = 250;
	x1flg.ROM_SW = 1;
	x1flg.ROM_TYPE = ROM_TYPE;
	x1flg.SOUND_SW = SOUND_SW;
	x1flg.DIP_SW = DIP_SW;

	textdrawproc_renewal();
	ipl_load();
#if 0
	x1_mem_init();
	x1_memset_bios();
#else
	RAM0r = mBIOS;
	RAM0w = mMAIN;
#endif


	Z80_Reset();
	clndr_init();

	init_fdc();
	init_scpu();
	init_8255();
	init_crtc();
	init_vram();

	init_dma();
	init_ctc();
	init_pcg();
}



/***********************************************************************
	s^I
***********************************************************************/

static	BYTE	keyintcnt = 0;
static	BYTE	flame = 0;
static	BYTE	inttiming = 0;

void x1r_init(void) {

	TRACE_START();

	init_draw();
	fnt_load();
	reset_x1(xmilcfg.ROM_TYPE, xmilcfg.SOUND_SW, xmilcfg.DIP_SW);

	timer_init(60);

	x1_psg_cont();
	x1_opm_cont();
	keyboard_init();
	keyboard_reset();
	timer_setcount(0);
}


void x1r_exec(void) {

	v_cnt = 0;
	s_cnt = 0;
	xmilcfg.DISPSYNC &= 1;

	inttiming = (xmilcfg.CPU8MHz & 1);

	while(s_cnt < 266) {
		while(h_cnt < x1flg.HSYNC_CLK) {
			Z80_Execute();
			x1_dma();
		}
		h_cnt -= x1flg.HSYNC_CLK;
		inttiming ^= 2;
		if (inttiming != 3) {
			if (xmilcfg.SOUNDPLY) {
				STREAM_MAKES(pcmbufsize[s_cnt]);
			}
			s_cnt++;
			x1_ctc_int();
			if (!((++keyintcnt) & 15)) {// 9600bps(K)/10bit/60fps/266׽
				x1_sub_int();			// 1/16 炢^^;
			}
		}
		v_cnt++;
		if (crtc.CRT_YL == v_cnt) {
			pcg.vsync = 1;
			if (xmilcfg.DISPSYNC == 1) {
				xmilcfg.DISPSYNC |= 0x80;
				scrnupdate();
			}
		}
	}
	if (++flame >= 60) {
		flame = 0;
		clndr_inc();
	}
	if (!xmilcfg.SOUNDPLY) {
		STREAM_MAKES(framesoundcnt);
	}
	if (!(xmilcfg.DISPSYNC & 0x80)) {
		scrnupdate();
	}
}


void x1r_exec_p(void) {

	v_cnt = 0;
	s_cnt = 0;

	xmilcfg.DISPSYNC &= 1;
	inttiming = xmilcfg.CPU8MHz & 1;

	while(s_cnt < 266) {
		while(h_cnt < x1flg.HSYNC_CLK) {
			Z80_Execute();
			x1_dma();
		}
		h_cnt -= x1flg.HSYNC_CLK;
		inttiming ^= 2;
		if (inttiming != 3) {
			if (xmilcfg.SOUNDPLY) {
				STREAM_MAKES(pcmbufsize[s_cnt]);
			}
			s_cnt++;
			x1_ctc_int();
			if (!((++keyintcnt) & 15)) {// 9600bps(K)/10bit/60fps/266׽
				x1_sub_int();			// 1/16 炢^^;
			}
		}
		if (!(xmilcfg.DISPSYNC & 0x80)) {
			scrnupdate1line(v_cnt);
		}
		v_cnt++;
		if (crtc.CRT_YL == v_cnt) {
			pcg.vsync = 1;
			if (xmilcfg.DISPSYNC == 1) {
				xmilcfg.DISPSYNC |= 0x80;
				scrnupdatelast();
			}
		}
	}
	if (++flame >= 60) {
		flame = 0;
		clndr_inc();
	}
	if (!xmilcfg.SOUNDPLY) {
		STREAM_MAKES(framesoundcnt);
	}
	if (!(xmilcfg.DISPSYNC & 0x80)) {
		scrnupdatelast();
	}
}


void x1r_term(void) {

	timer_term();
	x1_opm_stop();
	x1_psg_stop();
	keyboard_term();
	TRACE_END();

	x1_set_fd(0, 0, NULL);
	x1_set_fd(1, 0, NULL);
	x1_set_fd(2, 0, NULL);
	x1_set_fd(3, 0, NULL);
}



X1_IOR x1_dipsw_r(WORD port) {

	return(x1flg.DIP_SW);
}
